From 71e941156d6e3319f756dcfed8cbd5c0960fd13e Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Apr 16 2015 17:13:46 +0000
Subject: [PATCH 2/1001] Style up widgets just a bit.


---

diff --git a/hubs/models.py b/hubs/models.py
index 74b935f..4c5bcdf 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -82,6 +82,11 @@ class Hub(BASE):
     name = sa.Column(sa.String(50), primary_key=True)
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
     widgets = relation('Widget', backref=backref('hub'))
+    left_width = sa.Column(sa.Integer, nullable=False, default=8)
+
+    @property
+    def right_width(self):
+        return 12 - self.left_width
 
     @property
     def left_widgets(self):
diff --git a/hubs/widgets/chrome.py b/hubs/widgets/chrome.py
new file mode 100644
index 0000000..16d27e6
--- /dev/null
+++ b/hubs/widgets/chrome.py
@@ -0,0 +1,28 @@
+
+_panel_template = """
+<div class="panel panel-default">
+  {heading}
+  <div class="panel-body">
+    {content}
+  </div> <!-- end panel-body -->
+</div> <!-- end panel -->
+"""
+
+_panel_heading_template = """
+  <div class="panel-heading">
+    <h3 class="panel-title">
+      {title}
+    </h3>
+  </div> <!-- end panel-heading -->
+"""
+
+def panel(title=None):
+    def decorator(func):
+        def inner(*args, **kwargs):
+            heading = ''
+            if title:
+                heading = _panel_heading_template.format(title=title)
+            content = func(*args, **kwargs)
+            return _panel_template.format(content=content, heading=heading)
+        return inner
+    return decorator
diff --git a/hubs/widgets/dummy.py b/hubs/widgets/dummy.py
index 79d551d..b2e0983 100644
--- a/hubs/widgets/dummy.py
+++ b/hubs/widgets/dummy.py
@@ -1,3 +1,5 @@
+from chrome import panel
 
+@panel("This is a dummy widget")
 def render(request, session, config):
-    return "hello"
+    return "hello world"

